# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Hdinsight::Mgmt::V2015_03_01_preview
  module Models
    #
    # The security profile which contains Ssh public key for the HDInsight
    # cluster.
    #
    class SecurityProfile

      include MsRestAzure

      # @return [DirectoryType] The directory type. Possible values include:
      # 'ActiveDirectory'
      attr_accessor :directory_type

      # @return [String] The organization's active directory domain.
      attr_accessor :domain

      # @return [String] The organizational unit within the Active Directory to
      # place the cluster and service accounts.
      attr_accessor :organizational_unit_dn

      # @return [Array<String>] The LDAPS protocol URLs to communicate with the
      # Active Directory.
      attr_accessor :ldaps_urls

      # @return [String] The domain user account that will have admin
      # privileges on the cluster.
      attr_accessor :domain_username

      # @return [String] The domain admin password.
      attr_accessor :domain_user_password

      # @return [Array<String>] Optional. The Distinguished Names for cluster
      # user groups
      attr_accessor :cluster_users_group_dns

      # @return [String] The resource ID of the user's Azure Active Directory
      # Domain Service.
      attr_accessor :aadds_resource_id

      # @return [String] User assigned identity that has permissions to read
      # and create cluster-related artifacts in the user's AADDS.
      attr_accessor :msi_resource_id


      #
      # Mapper for SecurityProfile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecurityProfile',
          type: {
            name: 'Composite',
            class_name: 'SecurityProfile',
            model_properties: {
              directory_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'directoryType',
                type: {
                  name: 'Enum',
                  module: 'DirectoryType'
                }
              },
              domain: {
                client_side_validation: true,
                required: false,
                serialized_name: 'domain',
                type: {
                  name: 'String'
                }
              },
              organizational_unit_dn: {
                client_side_validation: true,
                required: false,
                serialized_name: 'organizationalUnitDN',
                type: {
                  name: 'String'
                }
              },
              ldaps_urls: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ldapsUrls',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              domain_username: {
                client_side_validation: true,
                required: false,
                serialized_name: 'domainUsername',
                type: {
                  name: 'String'
                }
              },
              domain_user_password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'domainUserPassword',
                type: {
                  name: 'String'
                }
              },
              cluster_users_group_dns: {
                client_side_validation: true,
                required: false,
                serialized_name: 'clusterUsersGroupDNs',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              aadds_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'aaddsResourceId',
                type: {
                  name: 'String'
                }
              },
              msi_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'msiResourceId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
